<!--- Kill extra output. --->
<cfsilent>

<cffunction name="cfquery" access="public" returntype="query">
 <cfargument name="dsn" type="string" required="true">
 <cfargument name="sqlstring" type="string" required="true">
  <cfquery name="thisquery" datasource="#arguments.dsn#">
   #preservesinglequotes(arguments.sqlstring)#
  </cfquery> 
 <cfreturn thisquery>
</cffunction>

<CFSCRIPT>
    countImage = "";

    function GetIdOS(OperatingSystem)
    {
	    SQLString = "SELECT OsID, Total FROM tbl_stats_OSes WHERE OsName = '#arguments.OperatingSystem#'";
	    OsResult=cfquery(dsn="<ENTER YOUR DSN>",sqlstring=SQLString);

	    if (OsResult.recordCount neq 0)
	    {
		    NewTotal = OsResult.Total + 1;
		    Update = "UPDATE tbl_stats_OSes SET Total = #NewTotal# WHERE OsId = #OsResult.OsId#;SELECT @@identity as OsID from tbl_stats_OSes";
		    UpdateResults = cfquery(dsn="<ENTER YOUR DSN>",sqlstring=Update);
		    return OsResult.OsId;
	    }
	    else
	    {
		    Insert = "SET NOCOUNT ON;INSERT tbl_stats_OSes (OsName, Total) VALUES ('#arguments.OperatingSystem#', 1);SELECT @@identity as OsID from tbl_stats_OSes";
		    InsertResults = cfquery(dsn="<ENTER YOUR DSN>",sqlstring=Insert);
		    return InsertResults.OsID;
	    }
    }

    function GetIdColors(Colors)
    {
	    SQLString = "SELECT ColorId, Total FROM tbl_stats_Colors WHERE ColorName = '#arguments.Colors#'";
	    OsResult=cfquery(dsn="<ENTER YOUR DSN>",sqlstring=SQLString);

	    if (OsResult.recordCount neq 0)
	    {
		    NewTotal = OsResult.Total + 1;
		    Update = "UPDATE tbl_stats_Colors SET Total = #NewTotal# WHERE ColorId = #OsResult.ColorId#;SELECT @@identity as ColorId from tbl_stats_Colors";
		    UpdateResults = cfquery(dsn="<ENTER YOUR DSN>",sqlstring=Update);
		    return OsResult.ColorId;
	    }
	    else
	    {
		    Insert = "SET NOCOUNT ON;INSERT tbl_stats_Colors (ColorName, Total) VALUES ('#arguments.Colors#', 1);SELECT @@identity as ColorId from tbl_stats_Colors";
		    InsertResults = cfquery(dsn="<ENTER YOUR DSN>",sqlstring=Insert);
		    return InsertResults.ColorId;
	    }
    }

    function GetIdRes(Resolution)
    {
	    SQLString = "SELECT ResId, Total FROM tbl_stats_Resolutions WHERE ResName = '#arguments.Resolution#'";
	    OsResult=cfquery(dsn="<ENTER YOUR DSN>",sqlstring=SQLString);

	    if (OsResult.recordCount neq 0)
	    {
		    NewTotal = OsResult.Total + 1;
		    Update = "UPDATE tbl_stats_Resolutions SET Total = #NewTotal# WHERE ResId = #OsResult.ResId#;SELECT @@identity as ResId from tbl_stats_Resolutions";
		    UpdateResults = cfquery(dsn="<ENTER YOUR DSN>",sqlstring=Update);
		    return OsResult.ResId;
	    }
	    else
	    {
		    Insert = "SET NOCOUNT ON;INSERT tbl_stats_Resolutions (ResName, Total) VALUES ('#arguments.Resolution#', 1);SELECT @@identity as ResId from tbl_stats_Resolutions";
		    InsertResults = cfquery(dsn="<ENTER YOUR DSN>",sqlstring=Insert);
		    return InsertResults.ResId;
	    }
    }

    function GetIdBrowser(Browser)
    {
	    SQLString = "SELECT BrowserId, Total FROM tbl_stats_Browsers WHERE BrowserName = '#arguments.Browser#'";
	    OsResult=cfquery(dsn="<ENTER YOUR DSN>",sqlstring=SQLString);

	    if (OsResult.recordCount neq 0)
	    {
		    NewTotal = OsResult.Total + 1;
		    Update = "UPDATE tbl_stats_Browsers SET Total = #NewTotal# WHERE BrowserId = #OsResult.BrowserId#;SELECT @@identity as BrowserId from tbl_stats_Browsers";
		    UpdateResults = cfquery(dsn="<ENTER YOUR DSN>",sqlstring=Update);
		    return OsResult.BrowserId;
	    }
	    else
	    {
		    Insert = "SET NOCOUNT ON;INSERT tbl_stats_Browsers (BrowserName, Total) VALUES ('#arguments.Browser#', 1);SELECT @@identity as BrowserId from tbl_stats_Browsers";
		    InsertResults = cfquery(dsn="<ENTER YOUR DSN>",sqlstring=Insert);
		    return InsertResults.BrowserId;
	    }
    }

    function GetIdLang(Language)
    {
	    SQLString = "SELECT LanguageId, Total FROM tbl_stats_Languages WHERE LanguageName = '#arguments.Language#'";
	    OsResult=cfquery(dsn="<ENTER YOUR DSN>",sqlstring=SQLString);

	    if (OsResult.recordCount neq 0)
	    {
		    NewTotal = OsResult.Total + 1;
		    Update = "UPDATE tbl_stats_Languages SET Total = #NewTotal# WHERE LanguageId = #OsResult.LanguageId#;SELECT @@identity as LanguageId from tbl_stats_Languages";
		    UpdateResults = cfquery(dsn="<ENTER YOUR DSN>",sqlstring=Update);
		    return OsResult.LanguageId;
	    }
	    else
	    {
		    Insert = "SET NOCOUNT ON;INSERT tbl_stats_Languages (LanguageName, Total) VALUES ('#arguments.Language#', 1);SELECT @@identity as LanguageId from tbl_stats_Languages";
		    InsertResults = cfquery(dsn="<ENTER YOUR DSN>",sqlstring=Insert);
		    return InsertResults.LanguageId;
	    }
    }

    function GetIdPath(Path)
    {
	    SQLString = "SELECT PathId, Total FROM tbl_stats_Paths WHERE PathName = '#arguments.Path#'";
	    OsResult=cfquery(dsn="<ENTER YOUR DSN>",sqlstring=SQLString);

	    if (OsResult.recordCount neq 0)
	    {
		    NewTotal = OsResult.Total + 1;
		    Update = "UPDATE tbl_stats_Paths SET Total = #NewTotal# WHERE PathId = #OsResult.PathId#;SELECT @@identity as PathId from tbl_stats_Paths";
		    UpdateResults = cfquery(dsn="<ENTER YOUR DSN>",sqlstring=Update);
		    return OsResult.PathId;
	    }
	    else
	    {
		    Insert = "SET NOCOUNT ON;INSERT tbl_stats_Paths (PathName, Total) VALUES ('#arguments.Path#', 1);SELECT @@identity as PathId from tbl_stats_Paths";
		    InsertResults = cfquery(dsn="<ENTER YOUR DSN>",sqlstring=Insert);
		    return InsertResults.PathId;
	    }
    }

    function GetOS(UserAgent)
    {
	    sOS = "(Unknown)";
	    if (UserAgent.IndexOf("98") GT 0) { sOS = "Win98"; }
	    if (UserAgent.IndexOf("95") GT 0) { sOS = "Win95"; }
	    if (UserAgent.IndexOf("Win 9x") GT 0) { sOS = "WinME"; }
	    if (UserAgent.IndexOf("NT") GT 0) { sOS = "WinNT"; }
	    if (UserAgent.IndexOf("NT 5") GT 0) { sOS = "Win2K"; }
	    if (UserAgent.IndexOf("NT 5.1") GT 0) { sOS = "WinXP"; }
	    if (UserAgent.IndexOf("NT 5.2") GT 0) { sOS = "Win2K3"; }
	    if (UserAgent.IndexOf("NT 6") GT 0) { sOS = "WinVista"; }
	    if (UserAgent.IndexOf("NT 6.1") GT 0) { sOS = "Windows7"; }
	    if (UserAgent.IndexOf("Linux") GT 0) { sOS = "Linux"; }
	    if (UserAgent.IndexOf("Mac") GT 0) { sOS = "Mac"; }

	    return sOS;
    }

    function getBrowserVersion(WebBrowser, UserAgent)
    {
	    results = REFind((WebBrowser & "[/\s]*\d*\.?\d*\.?\d*"),UserAgent,1,True);

	    if(results.len[1] GT 0)
	    {
			return Mid(UserAgent,results.pos[1],results.len[1]);
	    }
	    else
	    {
			return WebBrowser;
	    }
    }

    function GetBrowser(UserAgent)
    {
	    sBrowser = "(Unknown)";
	    if (UserAgent.IndexOf("Mozilla") GT 0) { sBrowser = getBrowserVersion("Mozilla", UserAgent); }
	    if (UserAgent.IndexOf("Chrome") GT 0) { sBrowser = getBrowserVersion("Chrome", UserAgent); }
	    if (UserAgent.IndexOf("OmniWeb") GT 0) { sBrowser = "OmniWeb"; }
	    if (UserAgent.IndexOf("iCab") GT 0) { sBrowser = "iCab"; }
	    if (UserAgent.IndexOf("KDE") GT 0) { sBrowser = "Konqueror"; }
	    if (UserAgent.IndexOf("Camino") GT 0) { sBrowser = "Camino"; }
	    if (UserAgent.IndexOf("Netscape") GT 0) { sBrowser = getBrowserVersion("Netscape", UserAgent); }
	    if (UserAgent.IndexOf("MSIE") GT 0) { sBrowser = getBrowserVersion("MSIE", UserAgent); }
	    if (UserAgent.IndexOf("Gecko") GT 0) { sBrowser = getBrowserVersion("Gecko", UserAgent); }
	    if (UserAgent.IndexOf("Apple") GT 0) { sBrowser = getBrowserVersion("Safari", UserAgent); }
	    if (UserAgent.IndexOf("Firefox") GT 0) { sBrowser = getBrowserVersion("Firefox", UserAgent); }

	    return sBrowser;
    }

    function LogStats()
    {
    if(isDefined("session.userid"))
    {
	    UserId = session.userid;
	    UserName = session.username;
	    AuthorityLevel = session.authoritylevel;
    }
    else
    {
	    UserName = "Anonymous";
	    UserId = "";
	    AuthorityLevel = "";
    }

    OS = getOs(CGI.HTTP_USER_AGENT);
    BrowserType = getBrowser(CGI.HTTP_USER_AGENT);

	if(isDefined("CGI.HTTP_ACCEPT_LANGUAGE"))
    {
		Language = CGI.HTTP_ACCEPT_LANGUAGE;
				
		if(Language.IndexOf(";") GT 0)
		{
			Language = Mid(Source, 1, Source.IndexOf(";"));
		}
    }
    else
    {
		Language = "(Unknown)";
    }
	
	
    IP = CGI.REMOTE_ADDR;
    LogDate = DateFormat(Now(),"mm/dd/yyyy");
    LogTime = TimeFormat(Now(), "hh:mm");

	if(isDefined("CGI.HTTP_REFERER"))
    {
		Source = CGI.HTTP_REFERER;
				
		if(Source.IndexOf("&") GT 0)
		{
			Source = Mid(Source, 1, Source.IndexOf("&"));
		}
    }
    else
    {
		Source = "(Home Page)";
    }
	
    if(isDefined("CGI.HTTP_REFERER"))
    {
	    Referrer = CGI.HTTP_REFERER;
	}
	else
	{
	    Referrer = "";
    }

	if(isDefined("url.res"))
    {
	    Resolution = url.res;
	}
	else
	{
	    Resolution = "(Unknown)";
    }
	
	if(isDefined("url.js"))
    {
	    JavaScriptEnabled = url.js;
	}
	else
	{
	    JavaScriptEnabled = "(Unknown)";
    }
	
	if(isDefined("url.col"))
    {
	    Colors = url.col;
	}
	else
	{
	    Colors = "(Unknown)";
    }
	
    IdOs = GetIdOS(OS);
    IdColors = GetIdColors(Colors);
    IdRes = GetIdRes(Resolution);
    IdBrowser = GetIdBrowser(BrowserType);
    IdLang = GetIdLang(Language);
    IdPath =  GetIdPath(Source);

    Insert = "SET NOCOUNT ON;INSERT INTO tbl_Stats_Stats(username, [date], [time], ip, osid, colorid, browserid, resid, pathid,languageid) VALUES ('#UserName#', '#LogDate#', '#LogTime#', '#IP#', #IdOs#, #IdColors#, #IdBrowser#, #IdRes#, #IdPath#, #IdLang#);SELECT @@identity as LanguageId from tbl_stats_Languages";
    InsertResults = cfquery(dsn="<ENTER YOUR DSN>",sqlstring=Insert);
    return InsertResults.LanguageId;
    }

    LogStats();

</CFSCRIPT>

    <!--- Forward image request to actual image file. --->
    <cflocation url="#countImage#" addtoken="false" />

</cfsilent>
